<?php

#######################################
############ Instllningar ############

$LocalDir		= "C:\\WebDoc\\Scan\\";
$TokenKey		= "";
$ToPatient		= TRUE;
$DocTypeID		= "1";
$Loop			= TRUE;
$maxFileSize	= 20; //in Mb
$fileAge		= 5;  //in seconds
$sleep			= 5;  //in seconds

######################################

function CurlSendFile($file) {
	global $TokenKey, $ToPatient, $DocTypeID;

	if($ToPatient)
		$ToPatientString = "true";
	else
		$ToPatientString = "false";

	$ch = curl_init();

	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_SSLVERSION, FALSE);
	curl_setopt($ch, CURLOPT_URL,
		"https://webdoc.atlan.se/upload.php?action=http_upload".
		"&SecurityKey=$TokenKey".
		"&ToPatient=$ToPatientString".
		"&DocTypeID=$DocTypeID");

	curl_setopt($ch, CURLOPT_PORT, 443);
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	$post = array("image" => '@'.$file);
	//$post = array("image" => new \CURLFile($file));
	//curl_setopt($ch, CURLOPT_SAFE_UPLOAD, true);
		
	curl_setopt($ch, CURLOPT_POSTFIELDS, $post);

	curl_exec($ch);
	
	if(curl_errno($ch)) {
		echo curl_error($ch);
		return FALSE;
	} else {
		$CurlStatus = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		echo "CURL: ".$CurlStatus."\n";
		if($CurlStatus == 200)
			return TRUE;
		else
			return FALSE;
	}
	return FALSE;
}

function ScanDirSend($LocalDir, $pnr) {
	global $maxFileSize, $fileAge, $sleep;
	$Extensions = array("jpg","JPG","jpeg","JPEG","png","bmp","tga","pdf","PDF","tif","gif","GIF");

	$files = glob($LocalDir.'*');
	array_multisort( array_map( 'filemtime', $files ), SORT_NUMERIC, SORT_ASC, $files);

	foreach($files as $file) {
		$pathinfo = pathinfo($file);
		$toPatientFile = $LocalDir . $pnr . "_" . $pathinfo['basename'];
		$howOld = time() - filemtime($file);

		if (!in_array($pathinfo['extension'], $Extensions)) {
			continue;
		}

		if ($howOld < $fileAge) {
			continue;
		}

		if (filesize($file) > $maxFileSize * 1000000) {
			echo "$file: FEL: filen kunde inte skickas, maximal filstorlek $maxFileSize Mb\n";
			continue;
		}

		if (!rename($file, $toPatientFile)) {
			echo $file . ": FEL: kunde inte dpa om filen.\n";
			continue;
		}

		if (CurlSendFile($toPatientFile)) {
			echo $file.": OK: filen skickades till Webdoc."."\n";
			unlink($toPatientFile);
		} else {
			echo $toPatientFile.": FEL: filen kunde inte skickas Webdoc."."\n";
		}
	}
}

function loopThroughPatientFolders() {
	global $LocalDir;

	$dirHandle = opendir($LocalDir);
	while ($file = readdir($dirHandle)) {
		if (is_dir($LocalDir . $file) && $file != '.' && $file != '..') {
			$pnr = str_replace("-", "", $file);
			$pnr = substr($pnr, 0, 12);
			ScanDirSend($LocalDir . $file . DIRECTORY_SEPARATOR, $pnr);
		}
	}
}

if ($Loop) {
	while(is_dir($LocalDir)) {
		loopThroughPatientFolders();
		sleep($sleep);
	}
	die("FEL: kunde ej lsa frn $LocalDir");
} else {
	if(is_dir($LocalDir))
		loopThroughPatientFolders();
	else
		die("FEL: kunde ej lsa frn $LocalDir");
}
?>
